var Back = {
	flag: null,
	backList: null	 
}



Back.init = function() {
	console.log('Back.init();');
	
	Back.backList = new Array();
	Back.flag = false;
	Back.changeIcon();

	return true;
} 


Back.deInit = function() {
	console.log('Back.deInit();');
}



Back.add = function( screenName, status ) {
	console.log('Back.add(); ' + screenName + ' ' + status );
	Back.backList.push( { screen: screenName, status: status } );
	Back.setFlag( true );
	Back.changeIcon();
}

Back.setFlag = function( new_flag ) {
	Back.flag = new_flag;
}

Back.goBack = function() {
	console.log( 'Back.goBack: ' + Back.flag + ' length: ' + Back.backList.length );
	
	if (Back.flag) {
		if ( Back.backList.length < 2 ) return;
		Back.backList.pop();
	} else if ( Back.backList.length < 1 ) return;
	
	
	object = Back.backList.pop();
	console.log( 'object.screen: ' + object.screen );
	
	switch ( object.screen ) {
		case 'selectCity'://to region and direction select screen
		case 'bigMap'://to map for current direction to choose stations 
		case 'selectFavored'://alphabet for search stations data
		
		case 'selectMap'://TEST
		case 'selectInfo'://TEST
		case 'selectGPS'://TEST
		case 'selectCalendar'://TEST
			GUI.setScreen( object.screen );
			break;
		case 'selectStation'://list of trains on that station
			Protocol.getStationData( object.status.index, object.status.str );
			break;
		case 'selectTrain'://list of stations of current train marchroute
			Protocol.getTrainData( object.status.index, object.status.date );
			break;
		case 'selectRasp'://alphabet for search stations data
			Protocol.getRaspData( object.status.index1, object.status.index2, object.status.date );
			break;
		case 'selectRasp2'://alphabet for search stations data
			Protocol.getRasp2Data( object.status.index1, object.status.index2, object.status.date, object.status.station );
			break;
	}
	Back.changeIcon();
}



Back.changeIcon = function() {
	console.log( 'Back.backList.length: ' + Back.backList.length );
	
	if (( Back.flag && Back.backList.length < 2 ) || Back.backList.length < 1 ) {
		//gray
		$('button_favored').style.backgroundImage  = "url(images/icon_back_gray.png)";
	} else {
		//norm
		$('button_favored').style.backgroundImage  = "url(images/icon_back.png)";
	}
}
