﻿var GUI = {
	currentScreen: null,
	currentCity: null,
	currentDirection: null,
	
	currentDate: null,
	currentStation: null,
	trainList: [],//for station screen to define clicks
	stationList: [],//for train screen to define clicks
	currentStations: [],//station coord for current map
	currentCityStations: [],
	
	currentSearchList: null,
	
	currentSearch: null,
	searchData: [{
		name: "",
		index: 0
	}, {
		name: "",
		index: 0
	}],
	
	twoStationsFlag: true,
	
	menulist: null
}


GUI.init = function() {
	console.log('GUI.init();');
	GUI.currentScreen = "splashScreen";
	
	var today = new Date();
	GUI.currentDate = '';
	GUI.currentDate += ( today.getDate() < 10 ? '0' : '' ) + today.getDate().toString() + '.';
	GUI.currentDate += ( today.getMonth() < 9 ? '0' : '' ) + (today.getMonth() + 1).toString() + '.';
	GUI.currentDate += today.getYear() + 1900 + '.';
	GUI.currentDate += today.getDay();
	
	GUI.showMenu = false;
	
	GUI.setDate();
	return true;
}


GUI.deinit = function() {
	console.log('GUI.deInit();');
}



GUI.setScreen = function(newScreen) {
	Helper.applyCorrectStyles();
	Helper.show('bottom_cansel', false);
	GUI.showMenu = false;
	
	switch (newScreen) {
		case 'splashScreen':
			Helper.show('splashScreen', true);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', false);
			
			Helper.show('statusBar', false);
			Helper.show('top', false);
			
			Helper.show('bottom', false);
			
			define.getKeyData();
			define.getStations0();
			define.loadHeader();
			
			window.setTimeout('if ( GUI.currentScreen == "splashScreen" ) GUI.setScreen("selectCity");', 5000);
			Back.setFlag(false);
			break;
			
		case 'selectCity'://to region and direction select screen
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.selectCity();
			Back.init();//nullify back list;
			Back.add('selectCity');
			break;
			
		case 'bigMap'://to map for current direction to choose stations 
			Helper.show('splashScreen', false);
			
			Helper.show('map', true);
			Helper.show('ovimap', false);
			Helper.show('content', false);
			
			Helper.show('statusBar', true);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.bigMap();
			Back.add('bigMap');
			break;
		case 'selectMap'://ovi map
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', true);
			Helper.show('content', false);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			//TEST
			//Back.setFlag( false );
			Back.add('selectMap');
			break;
			
			
		case 'selectStation'://list of trains on that station
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.selectStation();
			break;
		case 'selectTrain'://list of stations of current train marchroute
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.selectTrain();
			break;
			
		case 'selectRasp'://
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.setHeader(true);
			break;
		case 'selectRasp2'://
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.selectRasp2();
			GUI.setHeader(true);
			break;
			
			
			
		case 'selectFavored'://alphabet for search stations data
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			GUI.selectFavored();
			Back.add('selectFavored');
			break;
			
		case 'selectInfo'://info screen
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			//TEST
			//Back.setFlag( false );
			Back.add('selectInfo');
			GUI.selectInfo();
			break;
			
		case 'selectHelp'://info screen
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			//TEST
			//Back.setFlag( false );
			Back.add('selectHelp');
			GUI.selectHelp();
			break;
			
		case 'selectGPS'://info screen
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', false);
			Helper.show('top', true);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			Helper.show('bottom', true);
			
			//TEST
			//Back.setFlag( false );
			Back.add('selectGPS');
			GUI.selectGPS();
			break;
			
		case 'selectInput'://input screen
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', true);
			Helper.show('top', false);
			
			Helper.show('inputBox', true);
			Helper.show('menulist', false);
			Helper.show('menubottom', true);
			Helper.show('bottom', false);
			
			Back.setFlag(false);
			break;
			
		case 'selectCalendar'://calendar
			Helper.show('splashScreen', false);
			
			Helper.show('map', false);
			Helper.show('ovimap', false);
			Helper.show('content', true);
			
			Helper.show('statusBar', true);
			Helper.show('top', false);
			
			Helper.show('inputBox', false);
			Helper.show('menulist', false);
			Helper.show('menubottom', false);
			//Helper.show('bottom', false);
			Helper.show('bottom', true);
			
			//TEST
			//Back.setFlag( false );
			Back.add('selectCalendar');
			GUI.selectCalendar();
			break;
	}
	
	GUI.currentScreen = newScreen;
	GUI.setPadding();
}

GUI.selectCity = function(index) {
	console.log('GUI.selectCity ' + index);
	GUI.currentDirection = null;
	$('input3_td').innerHTML = '';
	$('statusBar').innerHTML = '';
	
	if (index == null) {
		if (define.favoredCity == null) {
			define.favoredCity = 0;
			GUI.currentCity = 0;
		} else {
			GUI.currentCity = define.favoredCity;
		}
		
		var feed = '';
		//'<div class="topHeader lefty">' + define.SELECT_CITY + '</div>';
		
		if (GUI.currentCity == 0) {
			feed += '<div class="cityButtons"><image src="images/btn_moskva_select.png"></div>'
			feed += '<div class="cityButtons"><image src="images/btn_s-p.png" onclick="GUI.selectCity(1)" feedback="50"></div>'
		} else {
			feed += '<div class="cityButtons"><image src="images/btn_moskva.png" onclick="GUI.selectCity(0)" feedback="50"></div>'
			feed += '<div class="cityButtons"><image src="images/btn_s-p_select.png"></div>'
		}
		
		/*for (var i = 0, len = define.Cities.length; i < len; i++) {
			//feed += '<div class="dateSelect' + (GUI.currentCity == i ? " bold" : "") + '" style="padding:10px;" onclick="GUI.selectCity(' + i + ')">';
			feed += '<div class="dateSelect lefty" style="padding:10px;" onclick="GUI.selectCity(' + i + ')">';
			feed += '<image style="padding-top:3px;" src="images/icon_' + (i == GUI.currentCity ? "" : "un") + 'select.png" align="left"/>';
			feed += '<div class="lefty">' + define.Cities[i] + '</div></div>';
			//feed += '<div class="menuItem lefty" onclick="GUI.selectCity(' + i + ');">';
		}*/
		
		//feed += '<br><div class="topHeader lefty">' + define.SELECT_DIRECTION + '</div>';
		feed += '<br/><div class="upBorder"></div><br/>';
		//feed += '<br/><table width="100%"><tr><td class="setBorder"></td></tr></table><br/>';
		
		var direction_array = null;
		if (GUI.currentCity == 0) {
			direction_array = define.Moscow;
		} else {
			direction_array = define.SainPetersburg;
		}
		for (var i = 0, len = direction_array.length; i < len; i++) {
			if (GUI.currentCity == 0 && i == 8) continue;
			
			feed += '<div class="dateSelect lefty" onclick="GUI.selectCity(' + (10 + i) + ')" style="padding:10px;">';
			//feed += '<image style="padding-top:4px;" src="images/icon_' + (i == GUI.currentDirection ? "" : "un") + 'select.png" align="left"/>';
			feed += direction_array[i] + '</div>';
		}
		feed += '<br/><br/>';
		$('content').innerHTML = feed;
		GUI.setHeader();
	} else if (index < 2) {
		if (GUI.currentCity != index) {
			GUI.searchData[0].name = '';
			GUI.searchData[1].name = '';
			GUI.searchData[0].index = '';
			GUI.searchData[1].index = '';
			define.saveHeader();
			
			$('input1').value = 'Откуда';
			$('input1').className = 'inputStr gray';
			$('input2').value = 'Куда';
			$('input2').className = 'inputStr gray';
			
			define.favoredCity = index;
			GUI.currentCity = index;
			GUI.currentDirection = null;
			define.saveKeyData();
			GUI.setScreen('selectCity');//redraw directions
		}
	} else {
		index -= 9;
		GUI.currentDirection = index;
		GUI.setScreen('bigMap');
	}
}

GUI.bigMap = function() {
	console.log('GUI.bigMap');
	//console.log( 'currentCity ' + GUI.currentCity + ' currentDirection ' + GUI.currentDirection );
	
	if (GUI.currentCity == 0) {
		GUI.setStatus(define.Moscow_dir[GUI.currentDirection - 1]);
	} else {
		GUI.setStatus(define.SainPetersburg_dir[GUI.currentDirection - 1]);
	}
	
	
	var src = "data/";
	src += (GUI.currentCity == 0 ? "moscow/" : "piter/");
	src += (GUI.currentDirection < 10 ? ("0" + GUI.currentDirection) : (GUI.currentDirection));
	src += "/";
	src += (GUI.currentDirection < 10 ? ("0" + GUI.currentDirection) : (GUI.currentDirection));
	src += (GUI.currentCity == 0 ? "_msk" : "_spb");
	//console.log( 'src ' + src );
	feed = '<img src="' + src + '.png" onclick="GUI.click(event)">';
	
	GUI.currentStations = [];
	//for circle no data!!!
	if (GUI.currentDirection != 9) 
		Protocol.getCurrentStations(src + '.txt');
	
	GUI.clearData();
	$('map').innerHTML = feed;
}

GUI.click = function(event) {
	x = event.clientX + (document.documentElement.scrollLeft ? document.documentElement.scrollLeft : document.body.scrollLeft);
	y = event.clientY + (document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop);
	
	y -= parseInt($('content').style.paddingTop);
	//y -= ( Helper.isLandscape() ? define.CONTENT_DX_LANDSCAPE : define.CONTENT_DX );
	//console.log( 'x:' + x + ' y:' + y + ' GUI.currentStations.length: ' + GUI.currentStations.length );
	
	
	for (var i = 0, len = GUI.currentStations.length; i < len; i++) {
		if (x > GUI.currentStations[i].x && x < GUI.currentStations[i].x + 150 &&
		y > GUI.currentStations[i].y &&
		y < GUI.currentStations[i].y + 18) {
		
			GUI.currentStation = GUI.currentStations[i].index;
			Protocol.getStationData(GUI.currentStations[i].index);
			//console.log( 'GUI.currentStation ' + GUI.currentStation );
			break;
		}
	}
}


//clicks on stationScreen(trains list)
GUI.selectStation = function(index) {
	console.log('GUI.selectStation ' + index);
	
	if (index == null) {
		GUI.setHeader(false);
		
		bottomfeed = '<div class="bottomOne"><div class="buttontext_small" onclick="GUI.selectStation(5);" feedback="50">Другие направления от этой станции</div></div>';
		
		$('menubottom').innerHTML = bottomfeed;
		Helper.show('menubottom', false);
	} else if (index == 5 && GUI.menulist != null) {
		//show direction list;
		if ($('menulist').className == 'menulist hidden') {
			$('menulist').innerHTML = GUI.menulist;
			Helper.show('menulist', true);
			Helper.show('bottom_cansel', false);
			Helper.show('bottom', true);
		} else {
			$('menulist').innerHTML = GUI.menulist;
			Helper.show('menulist', false);
			Helper.show('bottom_cansel', false);
			Helper.show('bottom', true);
		}
	}
}

GUI.clickStation = function(index) {
	console.log('GUI.clickStation ' + index);
	if (index != null) {
		GUI.clearData();
		GUI.setScreen('selectTrain');
		Protocol.getTrainData(GUI.trainList[index], GUI.currentDate);
	}
}


//clicks on train marchrouteScreen(stations list)
GUI.selectTrain = function(index) {
	console.log('GUI.selectStation ' + index);
	GUI.setHeader(true);
}

GUI.clickTrain = function(index) {
	console.log('GUI.clickTrain ' + index);
	if (index != null) {
		GUI.clearData();
		GUI.currentStation = GUI.stationList[index];
		GUI.setScreen('selectStation');
		Protocol.getStationData(GUI.currentStation);
	}
}


//clicks on stationScreen(trains list)
GUI.selectRasp2 = function(index) {
	console.log('GUI.selectStation ' + index);
	GUI.setHeader(true);
	
	bottomfeed = '<div class="bottomOne"><div class="buttontext_small" onclick="GUI.selectRasp2(5);" feedback="50">Выбрать станцию пересадки</div></div>';
	
	$('menubottom').innerHTML = bottomfeed;
	Helper.show('menubottom', false);
	
	if (index == 5) {
		//show direction list;
		if (GUI.menulist != null) {
			$('menulist').innerHTML = GUI.menulist;
			Helper.show('menulist', true);
		}
	}
}

//show saved stations
GUI.selectFavored = function(index) {
	console.log('GUI.selectFavored ' + index);
	
	if (index == null) {
		//search for correct stations;
		if (define.favoredCount != null && define.favoredCount > 0) {
			feed = '';
			tempFeed = '';
			
			for (var i = 0; i < define.favoredCount; i++) {
				flag = 0;
				j = 0;
				//set names
				while (j < GUI.currentCityStations[GUI.currentCity].length && flag < 2) {
					if (GUI.currentCityStations[GUI.currentCity][j].index == define.favoredArray[i].index0 && define.favoredArray[i].city == GUI.currentCity) {
						define.favoredArray[i].name0 = GUI.currentCityStations[GUI.currentCity][j].name;
						flag++;
					}
					if (GUI.currentCityStations[GUI.currentCity][j].index == define.favoredArray[i].index1 && define.favoredArray[i].city == GUI.currentCity) {
						define.favoredArray[i].name1 = GUI.currentCityStations[GUI.currentCity][j].name;
						flag++;
					}
					j++;
				}
				if (flag == 1) {
					tempFeed += '<div class="dateSelect" onclick="GUI.selectFavored(' + i + ')">';
					tempFeed += define.favoredArray[i].name0 + '</div>';
				} else if (flag == 2) {
					tempFeed += '<div class="dateSelect" onclick="GUI.selectFavored(' + i + ')">';
					tempFeed += define.favoredArray[i].name0 + ' &rarr ' + define.favoredArray[i].name1 + '</div>';
				}
			}
			
			if (tempFeed != '') {
				feed = '<div class="dateSelect" style="color:#000000">Избранные станции и маршруты</div><br/>' + tempFeed;
			} else {
				feed = '<div class="dateSelect" style="color:#000000">' + define.NO_ROUTE + '</div><br/>';
			}
		} else {
			feed = '<div class="dateSelect" style="color:#000000">' + define.NO_ROUTE + '</div><br/>';
		}
		feed += '<br/>';
		$('content').innerHTML = feed;
	} else {
		//console.log( 'define.favoredArray[index].index0 ' + define.favoredArray[index].index0 );
		//console.log( 'define.favoredArray[index].name0 ' + define.favoredArray[index].name0 );
		//console.log( 'define.favoredArray[index].index1 ' + define.favoredArray[index].index1 );
		//console.log( 'define.favoredArray[index].name1 ' + define.favoredArray[index].name1 );
		
		if (define.favoredArray[index].index1 == undefined || define.favoredArray[index].index1 == '') {
			GUI.currentStation = define.favoredArray[index].index0;
			Protocol.getStationData(define.favoredArray[index].index0);
		} else {
			Protocol.getRaspData(define.favoredArray[index].index0, define.favoredArray[index].index1, define.favoredArray[index].date);
			//set in header station data
			
			GUI.searchData[0].name = define.favoredArray[index].name0;
			GUI.searchData[0].index = define.favoredArray[index].index0;
			$('input1').value = define.favoredArray[index].name0;
			$('input1').className = 'inputStr';
			
			
			GUI.searchData[1].name = define.favoredArray[index].name1;
			GUI.searchData[1].index = define.favoredArray[index].index1;
			$('input2').value = define.favoredArray[index].name1;
			$('input2').className = 'inputStr';
			
			define.saveHeader();
		}
	}
}

//click over input data
GUI.changeSearch = function(index) {
	console.log('GUI.changeSearch ' + index);
	
	bottomfeed = '<div class="bottomTwo"><div class="buttontext1" onclick="GUI.changeSearch(5);">';
	bottomfeed += '<table width="100%" height="100%">';
	bottomfeed += '<tr><td valign="center" feedback="50">Найти</td></tr>';
	bottomfeed += '</table>';
	//bottomfeed += 'Найти';
	bottomfeed += '</div></div>';
	
	bottomfeed += '<div class="bottomTwo"><div class="buttontext1" onclick="Back.goBack();">';
	bottomfeed += '<table width="100%" height="100%">';
	bottomfeed += '<tr><td valign="center" feedback="50">Отмена</td></tr>';
	bottomfeed += '</table>';
	//bottomfeed += 'Отмена';
	bottomfeed += '</div></div>';
	
	
	
	$('menubottom').innerHTML = bottomfeed;
	
	
	//hide top input;
	Helper.show('top', false);
	//show bottom input;
	Helper.show('inputBox', true);
	Helper.show('menulist', false);
	Helper.show('menubottom', true);
	Helper.show('bottom', false);
	
	
	if (index < 5) {
		var strToGo = ( index == 0 ? 'Откуда' : 'Куда');
		
		if (GUI.currentDirection != null) {
			if (GUI.currentCity == 0) {
				GUI.setStatus( 'Список станций <br/>' + strToGo + '<br/> (Москва: ' + define.Moscow_dir[GUI.currentDirection - 1] + ')');
			} else {
				GUI.setStatus( 'Список станций <br/>' + strToGo + '<br/> (Санкт-Петербург: ' + define.SainPetersburg_dir[GUI.currentDirection - 1] + ')');
			}
		} else {
			if (GUI.currentCity == 0) {
				GUI.setStatus( 'Список станций <br/>' + strToGo + '<br/> (Москва: все направления)');
			} else {
				GUI.setStatus( 'Список станций <br/>' + strToGo + '<br/> (Санкт-Петербург: все направления)');
			}
		}
		
		GUI.currentSearch = index;
		feed = '';
		
		//GUI.currentSearchList = new Array;
		GUI.currentSearchList = [];
		
		for (var i = 0, count = 0, len = GUI.currentCityStations[GUI.currentCity].length; i < len; i++) {
			directionIndex = GUI.currentCityStations[GUI.currentCity][i].index.toString();
			directionIndex = directionIndex.substr(-2);
			
			direction_I = GUI.currentDirection;
			if (GUI.currentCity == 1 && GUI.currentDirection > 4) 
				direction_I = 5;
			//console.log( 'GUI.currentCity ' + GUI.currentCity + ' GUI.currentDirection ' + GUI.currentDirection + 'direction_I ' + direction_I );
			
			if (GUI.currentDirection == null || parseInt(directionIndex) == direction_I) {
				directionIndex = (GUI.currentCity == 0 ? define.Moscow_small[parseInt(directionIndex) - 1] : define.SainPetersburg_small[parseInt(directionIndex) - 1]);
				if (directionIndex != undefined) 
					directionIndex = '(' + directionIndex + ')';
				else directionIndex = '';
				
				GUI.currentSearchList.push({
					name: GUI.currentCityStations[GUI.currentCity][i].name,
					index: GUI.currentCityStations[GUI.currentCity][i].index
				});
				
				feed += '<div class="dateSelect" onclick="GUI.changeSearch(';
				//feed += '<div class="cityItem lefty" onclick="GUI.changeSearch(';
				feed += (count + 10);
				feed += ')">';
				feed += GUI.currentCityStations[GUI.currentCity][i].name;
				if (GUI.currentDirection == null) 
					feed += directionIndex;
				feed += '</div>';
				count++;
			}
		}
		//alert( 'count ' + count );
		feed += '<br/><br/><br/><br/>';
		$('content').innerHTML = feed;
		
		$('inputbottom').value = 'Введите с клавиатуры';
		$('inputbottom').className = 'inputStrBot gray'; 
		
		$('inputbottom').onclick = function() {
			$('inputbottom').className = 'inputStrBot';
			$('inputbottom').value = '';
		};
		//Helper.show('searchList', true);
		GUI.setScreen('selectInput');
	} else if (index == 5 && $('inputbottom').value != '') {//search by 
		//GUI.currentSearchList = new Array;
		GUI.currentSearchList = [];
		
		feed = '';
		var count = 0;
		
		//check for preset searches (Москва and Санкт-Петербург) 
		if (GUI.currentCity == 0 && 'МОСКВА'.search($('inputbottom').value.toUpperCase()) != -1 //){
			&& GUI.searchData[1 - GUI.currentSearch].index != -1 ) {
				
			feed += '<div class="dateSelect" onclick="GUI.changeSearch(10);">Москва (все вокзалы)</div>';
			count++;
			
			GUI.currentSearchList.push({
				name: 'Москва (все вокзалы)',
				index: -1
			});
		} else if (GUI.currentCity == 1 && 'САНКТ-ПЕТЕРБУРГ'.search($('inputbottom').value.toUpperCase()) != -1 //) {
			&&	GUI.searchData[1 - GUI.currentSearch].index != -1 ) {
				
			feed += '<div class="dateSelect" onclick="GUI.changeSearch(10);">Санкт-Петербург (все вокзалы)</div>';
			count++;
			
			GUI.currentSearchList.push({
				name: 'Санкт-Петербург (все вокзалы)',
				index: -1
			});
		}
		
		
		for (var i = 0, len = GUI.currentCityStations[GUI.currentCity].length; i < len; i++) {
			directionIndex = GUI.currentCityStations[GUI.currentCity][i].index.toString();
			directionIndex = directionIndex.substr(-2);
			
			direction_I = GUI.currentDirection;
			if (GUI.currentCity == 1 && GUI.currentDirection > 4) 
				direction_I = 5;
			//console.log( 'GUI.currentCity ' + GUI.currentCity + ' GUI.currentDirection ' + GUI.currentDirection + 'direction_I ' + direction_I );
			
			if ((GUI.currentDirection == null || parseInt(directionIndex) == direction_I) &&
			(GUI.currentCityStations[GUI.currentCity][i].name.toUpperCase().search($('inputbottom').value.toUpperCase()) != -1)) {
			
				directionIndex = (GUI.currentCity == 0 ? define.Moscow_small[parseInt(directionIndex) - 1] : define.SainPetersburg_small[parseInt(directionIndex) - 1]);
				if (directionIndex != undefined) 
					directionIndex = '(' + directionIndex + ')';
				else directionIndex = '';
				
				GUI.currentSearchList.push({
					name: GUI.currentCityStations[GUI.currentCity][i].name,
					index: GUI.currentCityStations[GUI.currentCity][i].index
				});
				
				feed += '<div class="dateSelect" onclick="GUI.changeSearch(';
				//feed += '<div class="cityItem lefty" onclick="GUI.changeSearch(';
				feed += (count + 10);
				feed += ')">';
				feed += GUI.currentCityStations[GUI.currentCity][i].name;
				if (GUI.currentDirection == null) 
					feed += directionIndex;
				feed += '</div>';
				count++;
			}
		}
		
		if (count == 0) {
			feed += '<div class="cityItem center">' + define.NO_STATIONS + '</div>';
		}
		if (count == 1) { //if just one result - autoselect
			GUI.changeSearch(10);
			return;
		}
		feed += '<br/>';
		$('content').innerHTML = feed;
	} else {
		index -= 10;
		
				
		GUI.searchData[GUI.currentSearch].name = GUI.currentSearchList[index].name;
		GUI.searchData[GUI.currentSearch].index = GUI.currentSearchList[index].index;
		$('input' + (GUI.currentSearch + 1)).value = GUI.currentSearchList[index].name;
		$('input' + (GUI.currentSearch + 1)).className = 'inputStr';
		define.saveHeader();
		
		//Helper.show('searchList', false);
		Back.goBack();
	}
}

//info screen
GUI.selectInfo = function() {
	feed = '';
	feed += define.INFO;
	feed += '<br/><br/>';
	$('content').innerHTML = feed;
}


//help screen
GUI.selectHelp = function() {
	feed = '';
	feed += define.HELP;
	feed += '<br/><br/>';
	$('content').innerHTML = feed;
}


//GPS screen
GUI.selectGPS = function() {
	GUI.clearData();
	window.setTimeout('getLocation();', 1000);
	//getLocation();
	//getLocationAsync();
}

GUI.selectCalendar = function(index) {
	console.log('GUI.selectCalendar: ' + index);
	
	var today = new Date();
	
	if (index == null) {
		GUI.setStatus('Дата поездки');
		
		feed = '<div class="dateSelect" onclick="GUI.selectCalendar( 0 );">';
		feed += 'Сегодня, ';
		feed += today.getDate().toString();
		feed += ' ';
		feed += define.MONTH_NAME[today.getMonth()];
		feed += ', ';
		feed += define.DAY_NAME[today.getDay()];
		feed += '</div>';
		
		feed += '<div class="dateSelect" onclick="GUI.selectCalendar( 1 );">';
		feed += 'Без даты ';
		feed += '</div>';
		
		var day = parseInt(today.getDate());
		var month = parseInt(today.getMonth());
		var day_name = parseInt(today.getDay());
		
		for (var i = 0; i < 30; i++) {
			day++;
			if (day > define.DAY_LIST[month]) {
				day -= define.DAY_LIST[month];
				month = (month + 1 == 12 ? 0 : month + 1);
			}
			day_name++;
			if (day_name > 6) 
				day_name -= 7;
			
			feed += '<div class="dateSelect" onclick="GUI.selectCalendar( ' + (10 + i) + ' );">';
			feed += day;
			feed += ' ';
			feed += define.MONTH_NAME[month];
			feed += ', ';
			feed += define.DAY_NAME[day_name];
			feed += '</div>';
		}
		
		$('content').innerHTML = feed;
	} else if (index < 10) {
		if (index == 0) {//today
			//TODO
			GUI.currentDate = '';
			GUI.currentDate += ( today.getDate() < 10 ? '0' : '' ) + today.getDate().toString() + '.';
			GUI.currentDate += ( today.getMonth() < 9 ? '0' : '' ) + (today.getMonth() + 1).toString() + '.';
			GUI.currentDate += today.getYear() + 1900 + '.';
			GUI.currentDate += today.getDay();
			Back.goBack();
		} else {//nodate
			//TODO
			GUI.currentDate = null;
			Back.goBack();
		}
	} else {
		var day = parseInt(today.getDate());
		var month = parseInt(today.getMonth());
		var year = parseInt(today.getYear()) + 1900;
		var day_name = parseInt(today.getDay());
		
		for (var i = 9; i < index; i++) {
			day++;
			if (day > define.DAY_LIST[month]) {
				day -= define.DAY_LIST[month];
				month++;
				if (month >= 12) {
					month -= 12;
					year++;
				}
			}
			day_name++;
			if (day_name > 6) 
				day_name -= 7;
		}
		
		GUI.currentDate = ( day < 10 ? '0' : '' ) + day + '.';
		GUI.currentDate += ( month < 9 ? '0' : '' ) + (month + 1).toString() + '.';
		GUI.currentDate += year + '.';
		GUI.currentDate += day_name;
		
		//console.log( 'GUI.currentDate ' + GUI.currentDate + '  day ' + day + ' month ' + month + ' year ' + year + ' day_name ' + day_name ); 
		Back.goBack();
	}
	
	//set date
	GUI.setDate();
}

GUI.press = function( index ) { //buttons press
	console.log('GUI.press();  ' + index );
	
	switch( index ) {
		case 'region':
			GUI.clearData();
			GUI.setScreen('selectCity');
			break;
		//FOOTER
		case 0://home - MENU
			//GUI.clearData();
			//GUI.setScreen('selectCity');
			GUI.showMenu = true;
			GUI.formMenu();
			break;
		case 1://gps screen - FAVORED
			GUI.clearData();
			//GUI.setScreen('selectGPS');
			GUI.setScreen('selectFavored');
			break;
		case 2://ovistore - SAME
			widget.openURL('http://store.ovi.com/');
			break;
		case 3://favored - BACK
			//GUI.clearData();
			//GUI.setScreen('selectFavored');
			Back.goBack();
			break;
			
			
			
		//HEADER
		case 'calendar':
			{
				GUI.clearData();
				GUI.setScreen('selectCalendar');
			}
			break;
		case 10://switch
			{
				var a = GUI.searchData[0].name;
				GUI.searchData[0].name = GUI.searchData[1].name;
				GUI.searchData[1].name = a;
				var b = GUI.searchData[0].index;
				GUI.searchData[0].index = GUI.searchData[1].index;
				GUI.searchData[1].index = b;
				
				$('input1').value = GUI.searchData[0].name;
				$('input2').value = GUI.searchData[1].name;
			}
			break;
		case 11://search0
			GUI.currentSearch = 0;
			GUI.clearData();
			GUI.setScreen('searchABC');
			break;
		case 12://search1
			GUI.currentSearch = 1;
			GUI.clearData();
			GUI.setScreen('searchABC');
			break;
		case 13://getData
			{
				GUI.tutuPress();
			}
			break;
		case 14://saveData
			//console.log(' GUI.searchData[0].name: ' + GUI.searchData[0].name + ' GUI.searchData[1].name: ' + GUI.searchData[1].name );
			if (GUI.searchData[0].name != "" && GUI.searchData[1].name != "") {
				//console.log( '00define.favoredCount ' + define.favoredCount );
				if (define.favoredCount == null) {
					define.favoredCount = 0;
					define.favoredArray = new Array;
					//console.log( '01define.favoredCount ' + define.favoredCount );
				} else {
					//check for double favored
					var flag = false;
					var i = 0;
					//console.log( '02define.favoredCount ' + define.favoredCount );
					while( i < define.favoredCount && !flag) {
						if ( ( define.favoredArray[i].index0 == GUI.searchData[0].index && 
							define.favoredArray[i].index1 == GUI.searchData[1].index ) ||
							GUI.searchData[0].index == GUI.searchData[1].index ) flag = true;
						i++;
					}
					if ( flag ) return;
					//console.log( '03define.favoredCount ' + define.favoredCount );
				}
				//console.log( '10define.favoredCount ' + define.favoredCount );
				define.favoredArray.push( { city: GUI.currentCity, 
										name0: GUI.searchData[0].name, index0: GUI.searchData[0].index,
										name1: GUI.searchData[1].name, index1: GUI.searchData[1].index } );
				//define.favoredArray[define.favoredCount].date = GUI.currentDate;
				//console.log('test: ' + define.favoredArray[define.favoredCount].name0 );
				define.favoredCount++;
				//console.log( '11define.favoredCount ' + define.favoredCount );
				define.saveKeyData();
				//console.log( '12define.favoredCount ' + define.favoredCount );
			}
			break;
			
		//third header div
		case 20://show calendar
			//TODO show calendar
			GUI.showCalendar();
			break;	
		case 21://null date
			$('calendar').innerHTML = define.DATE;
			GUI.currentDate = null;
			break;	
		case 22://goto map
			GUI.clearData();
			Helper.show( 'inputBox', false );
			Helper.show( 'menulist', false );
			Helper.show( 'menubottom', false );
			Helper.show( 'bottom_cansel', false );
			Map.setMap();
			break;	
			
			
			
		case 333://back
			Back.goBack();
			break;
		case 777://info screen
			GUI.clearData();
			GUI.setScreen('selectInfo');
			break;
		case 'help':
			GUI.clearData();
			GUI.setScreen('selectHelp');
			break;
		case 666://exit
			if ( confirm('Вы действительно хотите закрыть приложение?') ) window.close();
			break;
			
			
		case 'by_station':
			GUI.setHeader(false);
			GUI.setScreen('selectCity');
			break;
		case 'by_stations':
			GUI.setHeader(true);
			GUI.setScreen('selectCity');
			break;
			
		case 'clear_fav':
			define.favoredCount = 0;
			define.saveKeyData();
			GUI.setScreen('selectFavored');
			break;
			
		case 'add_st':
			if (define.favoredCount == null) {
				define.favoredCount = 0;
				define.favoredArray = new Array;
			}
			define.favoredArray.push( { city: GUI.currentCity, 
									name0: Protocol.last_name1, index0: Protocol.last_index1,
									name1: '', index1: '' } );
			
			define.favoredCount++;
			define.saveKeyData();
			GUI.formMenu();
			alert('Станция успешно добавлена');
			Helper.show( 'menulist', false );
			Helper.show( 'bottom_cansel', false );
			Helper.show( 'bottom', true );
			break;
		case 'add_rasp':
			if (define.favoredCount == null) {
				define.favoredCount = 0;
				define.favoredArray = new Array;
			}
			define.favoredArray.push( { city: GUI.currentCity, 
									name0: Protocol.last_name1, index0: Protocol.last_index1,
									name1: Protocol.last_name2, index1: Protocol.last_index2 } );
			
			define.favoredCount++;
			define.saveKeyData();
			GUI.formMenu();
			alert('Станции успешно добавлены');
			Helper.show( 'menulist', false );
			Helper.show( 'bottom_cansel', false );
			Helper.show( 'bottom', true );
			break;
		case 'rem_st':
			define.favoredArray.splice( GUI.favDel, 1 );
			define.favoredCount--;
			define.saveKeyData();
			//GUI.formMenu();
			alert('Станция успешно удалена');
			Helper.show( 'menulist', false );
			Helper.show( 'bottom_cansel', false );
			Helper.show( 'bottom', true );
			break;
		case 'rem_rasp':
			define.favoredArray.splice( GUI.favDel, 1 );
			define.favoredCount--;
			define.saveKeyData();
			//GUI.formMenu();
			alert('Станции успешно удалены');
			Helper.show( 'menulist', false );
			Helper.show( 'bottom_cansel', false );
			Helper.show( 'bottom', true );
			break;

		case 'cansel_bottom':
			GUI.showMenu = false;
			if ( GUI.currentScreen == "selectStation" ) Helper.show( 'menubottom', true );
			Helper.show( 'menulist', false );
			Helper.show( 'bottom_cansel', false );
			Helper.show( 'bottom', true );
			break;
	}
}


GUI.setHeader = function(flag) {
	if (flag == null) {
		flag = GUI.twoStationsFlag;
	} else {
		GUI.twoStationsFlag = flag;
	}
	
	Helper.show('input2', flag);
	Helper.show('input3', !flag);
	//nullify input2 data
	if (!flag) {
		GUI.searchData[1].name = "";
		$('input2').value = 'Куда';
		$('input2').className = 'inputStr gray hidden';
		
		define.saveHeader();
	}
}

GUI.formMenu = function() {
	feed = '<div>';
	GUI.favDel = -1;
	
	//to region
	feed += '<div class="buttontext_menu" onclick="GUI.press(\'region\');" feedback="50">';
	feed += 'Выбор региона';
	feed += '</div>';
	
	feed += '<div class="buttontext_menu" onclick="GUI.setScreen(\'selectGPS\');" feedback="50">';
	feed += 'Ближайшие станции';
	feed += '</div>';
	
	//change header
	if (GUI.twoStationsFlag) {
		feed += '<div class="buttontext_menu" onclick="GUI.press(\'by_station\');" feedback="50">';
		feed += 'Расписание по станции';
		feed += '</div>';
	} else {
		feed += '<div class="buttontext_menu" onclick="GUI.press(\'by_stations\');" feedback="50">';
		feed += 'Расписание между станциями';
		feed += '</div>';
	}
	
	//add to favored
	if (GUI.currentScreen == 'selectStation') {
		var flag = false;
		var i = 0;
		
		while( i < define.favoredCount && !flag) {
			if (define.favoredArray[i].index0 == Protocol.last_index1 &&
			(define.favoredArray[i].index1 == '' ||
			define.favoredArray[i].index1 == null ||
			define.favoredArray[i].index1 == undefined)) {
				flag = true;
				GUI.favDel = i;
			}
			
			i++;
		}
		
		if (define.favoredCount == null || !flag) {
			feed += '<div class="buttontext_menu" onclick="GUI.press(\'add_st\');" feedback="50">';
			feed += 'Добавить в избранное';
			feed += '</div>';
		} else {
			feed += '<div class="buttontext_menu" onclick="GUI.press(\'rem_st\');" feedback="50">';
			feed += 'Удалить из избранного';
			feed += '</div>';
		}
	}
	if (GUI.currentScreen == 'selectRasp' || GUI.currentScreen == 'selectRasp2') {
		var flag = false;
		var i = 0;
		
		while (i < define.favoredCount && !flag) {
			if ((define.favoredArray[i].index0 == Protocol.last_index1 &&
			define.favoredArray[i].index1 == Protocol.last_index2) ||
			Protocol.last_index1 == Protocol.last_index2) { 
				flag = true;
				GUI.favDel = i;
			}
			
			i++;
		}
		
		if (define.favoredCount == null || !flag) {
			feed += '<div class="buttontext_menu" onclick="GUI.press(\'add_rasp\');" feedback="50">';
			feed += 'Добавить в избранное';
			feed += '</div>';
		} else {
			feed += '<div class="buttontext_menu" onclick="GUI.press(\'rem_rasp\');" feedback="50">';
			feed += 'Удалить из избранного';
			feed += '</div>';
		}
	}
	
	//clear favored
	if (GUI.currentScreen == 'selectFavored' && define.favoredCount > 0) {
		feed += '<div class="buttontext_menu" onclick="GUI.press(\'clear_fav\');" feedback="50">';
		feed += 'Очистить список';
		feed += '</div>';
	}
	
	//show map
	if (GUI.currentScreen == 'selectStation') {
		feed += '<div class="buttontext_menu" onclick="GUI.press(22);" feedback="50">';
		feed += 'Станция на карте';
		feed += '</div>';
	}
	if (GUI.currentScreen == 'selectTrain') {
		feed += '<div class="buttontext_menu" onclick="GUI.press(22);" feedback="50">';
		feed += 'Маршрут на карте';
		feed += '</div>';
	}
	
	//help screen
	feed += '<div class="buttontext_menu" onclick="GUI.press(\'help\');" feedback="50">';
	feed += 'Справка';
	feed += '</div>';
	
	//info screen
	feed += '<div class="buttontext_menu" onclick="GUI.press(777);" feedback="50">';
	feed += 'О приложении';
	feed += '</div>';
	
	//exit
	feed += '<div class="buttontext_menu" onclick="GUI.press(666);" feedback="50">';
	feed += 'Выход из приложения';
	feed += '</div>';
	
	feed += '</div>';
	
	//alert(feed);
	
	$('menulist').innerHTML = feed;
	
	if (GUI.currentScreen == "selectStation") 
		Helper.show('menubottom', false);
	
	Helper.show('menulist', true);
	Helper.show('bottom_cansel', true);
	Helper.show('bottom', false);
}


GUI.setDate = function() {
	var dateTxt = 'Без <br/> даты';
	if (GUI.currentDate != null) {
		dateTxt = 'Дата <br/>';
		
		var dateArray = GUI.currentDate.split('.');
		dateTxt += dateArray[0] + '.' + dateArray[1] + ',&nbsp' + define.DAY_NAME[dateArray[3]];
	}
	$('dateTxt').innerHTML = dateTxt;
}

GUI.clearData = function() {
	//$('content').innerHTML = '<div class="cityItem center">' + define.PLEASE_WAIT + '</div>';
	$('content').innerHTML = '<div class="Loading"><img src="images/loading.gif"></div>';
	
	$('map').innerHTML = '';
	//$('ovi').innerHTML = '';
}

GUI.setStatus = function(str) {
	$('statusBar').innerHTML = str;
}

GUI.setPadding = function() {
	$('content').style.paddingTop = $('header').clientHeight + 'px';
	$('content').style.paddingBottom = $('footer').clientHeight + 'px';
	$('ovimap').style.paddingTop = $('header').clientHeight + 'px';
	$('ovimap').style.paddingBottom = $('footer').clientHeight + 'px';
	$('map').style.paddingTop = $('header').clientHeight + 'px';
	$('map').style.paddingBottom = $('footer').clientHeight + 'px';
	
	Main.onscroll();
}


GUI.tutuPress = function() {
	if (GUI.searchData[0].name != "" && GUI.searchData[1].name != "" && GUI.searchData[0].name != GUI.searchData[1].name ) {
		var indexes = { i0: GUI.searchData[0].index, i1: GUI.searchData[1].index };
		
		if ((GUI.searchData[0].index == -1 && GUI.searchData[1].index != -1) ||
			(GUI.searchData[0].index != -1 && GUI.searchData[1].index == -1)) {
			
			var changeSt = (GUI.searchData[0].index == -1 ? 0 : 1);
			/*var directionIndex = GUI.searchData[1 - changeSt].index.toString();
			directionIndex = 'i' + directionIndex.substr(-2);
			var searchData = (GUI.currentCity == 0) ? define.Moscow_search : define.SainPetersburg_search;
			indexes['i' + changeSt] = searchData[directionIndex].index;*/
			if ( GUI.currentCity == 0 ) indexes['i' + changeSt] = 20000;
			else indexes['i' + changeSt] = 20600;
		}
		
		Protocol.getRaspData( indexes.i0, indexes.i1, GUI.currentDate );
	} else if ( GUI.searchData[0].name != GUI.searchData[1].name ) {
		Protocol.getStationData( GUI.searchData[0].index );
	} else if (GUI.searchData[0].name != "" || GUI.searchData[1].name != "") {
		Protocol.getStationData((GUI.searchData[0].name != "" ? GUI.searchData[0].index : GUI.searchData[1].index));
	}
}
