﻿var Main = {
	currentLayout: null,
	currentCity: null,
	currentVersion: '0.5.5'
}

var sysinfo = null;
function tactileFeedback(event)
{
	var target = event.target;
	var feedback = target.attributes.feedback;
 
	if(feedback)
	{
		//sysinfo.startvibra(50, feedback.nodeValue);
		sysinfo.startvibra(10, feedback.nodeValue);
	}
}

Main.init = function(){
	sysinfo = document.getElementById("sysinfo");
 	document.addEventListener('click', tactileFeedback, false);
	
	Helper.applyCorrectStyles();
	widget.setNavigationEnabled( false );
	window.menu.hideSoftkeys();
		
	//alert('currentVersion: ' + Main.currentVersion);
	
	if ( Map.init() && Protocol.init() && GUI.init() && Back.init() && GPS.init() ) {
		console.log('Main.init();');
		
		GUI.setScreen('splashScreen');
		
		$('calendar').innerHTML = define.DATE;
		$('noDate').innerHTML = define.NO_DATE;
		$('title').innerHTML = define.BASE_TITLE;
	
		$('setDay').innerHTML = define.DAY;
		$('setMonth').innerHTML = define.MONTH;
		$('setYear').innerHTML = define.YEAR;
		
		//Protocol.getRasp2Data();
	} else {
		window.close();
	}
	//Map.setMap();
}

Main.deInit = function(){
	console.log('Main.deInit();');
}


Main.resize = function(){
	console.log('Main.resize()');
	Helper.applyCorrectStyles();
	//window.setTimeout( 'GUI.setPadding();', 100 );
	GUI.setPadding();
}


Main.onscroll = function(){
	var scrollHeight = 0;
	if ( GUI.currentScreen == "bigMap" ) scrollHeight = $('map').scrollHeight*1;
	else if ( GUI.currentScreen == "selectMap" ) scrollHeight = $('ovimap').scrollHeight*1;
	else scrollHeight = $('content').scrollHeight*1;
	$('scrollerBar').style.top = ( 100*window.pageYOffset / scrollHeight ) + '%';
	$('scrollerBar').style.height = ( 100*window.innerHeight / scrollHeight ) + '%';
	
	$('scroller').style.top = $('header').clientHeight + 'px';
	$('scroller').style.height = ( window.innerHeight*1 - ( $('header').clientHeight*1 + $('footer').clientHeight*1 )) + 'px';
	
	if ( 100*window.innerHeight / scrollHeight >= 99 ) {
		$('scroller').className = 'hidden';
	} else {
		$('scroller').className = '';
	}
	
}





$ = function(Id) {
	return document.getElementById(Id);
}

var ImagePreloader = {
	list: [],
	images: [],
	
	add: function( images ) {
		this.list = this.list.concat( images );
	},
	
	start: function() {
		for (var i = 0; i < this.list.length; i++) {
			var img = new Image();
			img.src = this.list[i];
			
			this.images.push( img );
		}		
	}
}

// Preload images before they are displayed to avoid flicker
// when loading them up for the first time.
function preloadImages() {
	ImagePreloader.add( [
		"images/splash.png",
		"images/btn_moskva_select.png",
		"images/btn_s-p.png",
		"images/btn_moskva.png",
		"images/btn_s-p_select.png"
		 ] );
	
	
	ImagePreloader.start();
}
